Consider using a vertical Icons-Only Task Manager populated with apps, and a thickened panel
Closed, ResolvedPublic

Description

This shook out of the discussion in D25773, and has also been previously discussed in https://bugs.kde.org/show_bug.cgi?id=399972.

In essence, I would like to consider the possibility of using a vertical Icons-Only Task Manager pre-populated with some apps by default, on a thickened panel. There are a variety of reasons why I think this change would be worthwhile and represents a better default:

  • Better for launching apps: An IOTM is first and foremost an app launcher. You pin apps to it and then launch them. The TTM can be configured this way, but it's more awkward since the launchers jump around as apps are opened. Given that launching apps is how the user begins the process of interacting with the computer, it makes sense to put app launching front-and-center and make it as discoverable as possible by pinning some commonly-used apps to it by default (e.g. System Settings, default filemanager, default web browser), as all other platforms do.
  • Better accommodates the user's mental model and interaction pattern: IOTMs organize tasks on the basis of apps, not windows. I think this maps better to the way most users perceive how their computers work: they open apps to perform tasks. The fact that apps open windows is incidental, and these days with window tabbing, most apps are single-window affairs anyway. The advantage that a TTM has in presenting tasks as windows rather than apps recedes over time as common workflows converge on the use of multiple apps each opening a single window.
  • Able to better accommodate touch use cases: IOTMs require a thickened panel to make sense, or else the click targets become much too small. But if we do thicken the panel and use an IOTM, then each task becomes a large square, making a perfect touch target--much more touch-friendly than the small rectangular TTM buttons of the current default thin panel. It would therefore better support touch interaction for convertibles and tablets without needing to change the UI at all.
  • Save precious vertical screen space: If we thicken the panel, then we're using up even more of the screen's vertical space, which is quite previous for the typical 16:9 displays of today's computers. However we can take the opportunity to move the panel to the left screen edge, like the old Unity layout. This would represent a net decrease in vertical screen space usage, leaving more room for content in most apps. This is even more effective with today's ultra-widescreen displays that people are starting to use; a horizontal panel wastes a ton of space on these screens. This part of the proposal is not required, but I think it would be a nice-to-have.
  • More visually attractive: IOTMs, expecially with double-thickness panels, are attractive because they showcase large versions of pretty app icons. They're just plain nice to look at.
  • Bandwagon/user familiarity: every other major OS ships the local equivalent of an IOTM, Including Windows (since 7), macOS, ChromeOS, Android, iOS, Ubuntu's GNOME, and formerly Ubuntu's Unity. Using an IOTM would also improve consistency with Plasma Mobile, which uses the local equivalent of an IOTM. The last major proprietary OS to ship a TTM was Windows Vista, more than 10 years ago, and the only major FOSS OS I know of that still ships with a TTM is RHEL. Other FOSS OS IOTM users are MX Linux, Linux Mint, ElementaryOS, Deepin, and Solus. I would therefore argue that most users are already accustomed to IOTMs at this point, and they're not unfamiliar, weird, or a big usability regression.

I kept noticing people using this setup, and started using it myself a while back and really like it, for all the reasons mentioned above. Notably, in my guerilla usability testing (T10047), the very first thing my test subject tried to do was switch to a vertical left screen edge IOTM.

Here's how it looks on my system:

This would be a big change. If we did it, I would want to wait until after Plasma 5.18 branches so we can try it out in a non-LTS release.

ngraham updated the task description. (Show Details)Dec 28 2019, 4:36 PM
ngraham updated the task description. (Show Details)
ndavis added a subscriber: ndavis.Dec 28 2019, 5:21 PM

I'll note that making the panel vertical is not a required element of this proposal; we could easily stay with a horizontal panel. I just think that going vertical makes sense as a logical next step to save precious vertical space if we're going to thicken the panel, which is desirable for better touch-friendliness.

ngraham updated the task description. (Show Details)Dec 28 2019, 7:07 PM

Thoughts: Task manager: icon-only. Panel: horizontal.

Reasoning: That's what Windows® uses, and Windows® is what people use.

I don't use IOTM myself though, mainly because the icons are way too small in the horizontal mode (add Firefox to a panel as a widget and pin it to the task manager, and compare the icon sizes).

I don't use IOTM myself though, mainly because the icons are way too small in the horizontal mode (add Firefox to a panel as a widget and pin it to the task manager, and compare the icon sizes).

Right, it's much nicer when you can make the panel thicker and get larger icons, but this takes up a lot of space for a horizontal panel (even though this is what Windows does, so apparently it's not that bad), which is why I'm recommending a double-thickness vertical panel.

Making the task manager icon-only: +1

Moving the panel to the left: I'm not sure about this; on one hand, it could help Plasma differentiate from Windows and other competitors, especially now that Unity is discontinued. On the other hand, it could be seen as a unnecessary change that might annoy people. Overall, I would be fine with it moving to the left. We should make sure to use vertical desktops by default though (or the switcher hitzone will reduce too much), and check that common widgets are usable in a vertical panel (e.g.: the system resource viewer isn't).

Increasing the panel thickness: -1. I know this is mostly a matter of opinions, but I can't really bring myself to like bit, colored icons on a panel, especially if they don't automatically fit in two columns.

IMO using an IOTM without thickening the panel does not make sense because the click targets become too small. They are hard enough to hit with a mouse or touchpad, and they becomes impossible with touch. There's a reason why most "Dock" style UIs use large icons and thick panels; it's the only way that the UI really makes any sense. Also a narrow vertical panel can't work because the clock becomes illegible (but it's fine with a double-thickness panel). If we aren't going to thicken the panel, then this proposal would be mostly a regression.

FWIW I really love seeing big colorful app icons on my panel. I think they're pretty. :) These apps where I spend most of my time and I like seeing their "faces", so to speak.

ngraham renamed this task from Consider using a vertical Icons-Only Task Manager populated with apps by default to Consider using a vertical Icons-Only Task Manager populated with apps, and a thickened panel.Dec 29 2019, 10:37 PM
ngraham updated the task description. (Show Details)
churaev added a comment.EditedDec 30 2019, 2:02 AM

Some testing and comparison with Microsoft® Windows® 10:

Observations:

  • Firefox icon added via "Add to Panel (Widget)" is much larger than the task a manager icons.
  • Windows® 10 uses the same (small) icon size as KDE.
  • Windows® 10 panel is only 4 pixels taller than the default KDE panel.
  • Windows® 10 task buttons a little wider than KDE task buttons, maybe increase buttons widths for small panel sizes?
  • When an application has more than one window, the "Present Windows" effect is used, and it just feels wrong to me... the GNOME 3 effect feels better somehow.
  • The task bar configuration dialog doesn't link to "Present Windows" options, how is one supposed to find them without knowing the name of the effect in advance?

I'm a fan of the Unity layout and I like using a side panel. That's not a good justification for giving this a +1, but Unity was very well optimized for laptops (in UI design) and laptops are the most common type of PC these days.

This comment was removed by churaev.

I think the way to cure fork-mania is for a clearly obvious choice to emerge that everyone gravitates to, and I think that thing is Plasma, and that we'll get there within a few years. :) But please don't hijack Phabricator tasks to bring up unrelated matters or rant about stuff. It makes it hard for developers to discuss and coordinate work (which is what it's for, after all).

I know all this is very off-topic, but I'll answer anyway. Just please don't add more off-topic questions to the task discussion. This isn't a forum for posting rants.

And please bring back the notification count 💯, no need to remove this feature, why...

The alignment of the text was impossible to get right (we think it was because of QML bugs) and we didn't think it was very necessary to know the exact number of "unread" notifications. The notifications aren't necessarily unread either if you read the popup and let it expire. This means there's often a number being displayed that keeps going up. It's distracting, which is the other justification for getting rid of the number. It's easier to mentally block out an icon that doesn't change except for the first time you don't dismiss a notification.

Also sorry I just want to vent, please forgive me, but... why Wayland, why QML, why replace Kicker with Plasma... 😢 X11, Qt Widgets, and Kicker are fine... ⚙️ why Nepomuk, why Akonadi, why Baloo, why... 😭 just why... why GNOME 3, why remove features, why PulseAudio, why Firefox Australis, why WebExtensions, why break API, ABI??? 😢 Just look what was done to Linux theming, it was once such a pleasure... 😿 Qt 4 and GTK 2, well you know... COOPERATED with one another, in a way... just like good free software projects should... and now there's a mess of theme-incompatible toolkits... 😭

You could find out the answers to all of these with a bit of searching. Kicker is actually an application menu that is still included with Plasma, not replaced by Plasma.

Forums... they're bursting with truth... 🗣️ upstream please listen... 👂 they aren't evil... they aren't your enemy... they want the best for the Linux desktop! 💌

We listen. You'll find many of us on social media like Reddit, regularly taking feedback.

Well then... Linux desktop was probably cursed some time during the KDE 3.5 support cycle... using literal black magic... 🧙 I know it's unwise to jump to paranormal explanations, but I'm at a total loss... 🤔 I mean what else could it be... I don't even know at this point... So until people realize that it's cursed and lift the curse somehow, the Linux desktop will never get anywhere... 🚧 bound to shatter itself with forks and reset itself to square one again and again... two steps forward, two steps back... and so on and on and on... and so the fake website I put into Falkon in my mockup will remain true...

This type of discussion is rarely productive and it usually takes place when/where the participants don't have a clear picture of what is actually happening.

What would really determine whether or not this is a good idea would be some usability testing, but I'm not sure how we would test something like this. It's a rather small difference that seems to be more a matter of preference and what one is used to. I'll try to see if I can get some people I know to switch to having the panel on the side and report back in a week, then maybe again after another week.

One disadvantage to using a vertical panel is that you run out of space for app icons in the task manager sooner. It's still usable since the icons shrink to accommodate new apps, but shrunken icons don't look as nice.

We should also consider how well increasing the panel thickness will work for 1366x768 displays since those are extremely common. I had a display with that resolution on my last laptop and I know I used a side panel because the vertical space was always very limited. I don't remember if I increased the thickness of my panel, but I think I did so that the systray would switch to using 2 columns and give me more space for apps.

Here's how it looks on my system:

churaev added a comment.EditedDec 31 2019, 7:33 AM

Deleted rant... here's how I wish the default panel looked (fake screenshot made in Inkscape):

I.e. please don't change anything, just tweak a bit to better imitate Windows® 10, but with bigger icons (both tasks and tray)...

Panel height is increased to 42 in this "screenshot", and the padding is removed to better accommodate 32x32 icons.

ndavis added a comment.EditedDec 31 2019, 7:33 AM

Yet another thing to consider:
Where should the hot corner for Present Windows go if we put the panel on the left?

  • If we keep it on the top left, it'll get in the way when people want to use the menu.
  • If we move it to the top right, it'll get in the way when people want to close a window.
    • We'll have to move the window buttons to the left if we do this, just like Unity and my screenshot.
  • If we move it to the bottom left, it's mostly out of the way, but it could get in the way when people go to minimize all windows. It's also a change just to accommodate another change.
  • If we move it to the bottom right, it's also mostly out of the way, but I would not be surprised if many people (besides myself) put their mouse cursor there as a resting place. It's the only place on the screen where the mouse cursor is almost completely hidden.

Why do we insist on changing the default to look like XYZ instead of promoting and improve T11743 ?

I don't think there is one workflow that fits all. E.g. IOTM is very cumbersome for anybody doing heavy multitasking (all app windows look the same) . And the TM on either side makes real long mouse travel distances for multi monitor setups. Unfortunately we have no actual data to about that, but I would imagine that workstations with multimonitor setup are a very big part of Plasmas user base.

Why do we insist on changing the default to look like XYZ instead of promoting and improve T11743 ?

So far nobody on the Plasma team is very enthusiastic about it. :( If other people want it, they're going to need to make their voices heard.

I don't think there is one workflow that fits all. E.g. IOTM is very cumbersome for anybody doing heavy multitasking (all app windows look the same) . And the TM on either side makes real long mouse travel distances for multi monitor setups. Unfortunately we have no actual data to about that, but I would imagine that workstations with multimonitor setup are a very big part of Plasmas user base.

There is no workflow that fits all, but we can make educated guesses about the workflow that fits most (this is the point of defaults, after all). As I mentioned in the description, I think the reason why this makes sense is because most users today have an app-based workflow moreso than a window-based workflow. This is due to the changing nature of how apps work today: more and more are single-window apps, with integrated tabbing features for working with multiple documents/views/emails/whatevers. I'll admit that this is a bit of an educated guess on my part, but it's based on observations of the functioning of apps used by me and others I know, and I think it's notable that every other platform has switched to a Dock-style paradigm. Clearly they all thought there was some advantage.

FWIW using a dock paradigm isn't bad for multitasking at all in my opinion; you just wind up using Present Windows when you find yourself needing to switch between windows when there are more than like 10 on the screen. I got used to this in my macOS days and it's quite fast. Windows itself seems to have moved to this model as well, as they now ship an IOTM equivalent and have an equivalent of the Present Windows effect.

Yet another thing to consider:
Where should the hot corner for Present Windows go if we put the panel on the left?

That's an excellent point that I hadn't considered! Seems like a thorny issue for sure. lol we could go full GNOME/Unity and merge the Present Windows effect into the Application Dashboard effect, and bind that to the Meta key by default such that it triggers when you click on the launcher button, move the cursor into the top-left corner, or hit the meta key. Our users would probably crucify us. Definitely a problem regarding what to do with that hotcorner.

If we used an IOTM but kept the panel where it is, and only increased its thickness by a bit (say, to 42-48px), I think that could be acceptable too:


(48px)

There is no workflow that fits all, but we can make educated guesses about the workflow that fits most (this is the point of defaults, after all). As I mentioned in the description, I think the reason why this makes sense is because most users today have an app-based workflow moreso than a window-based workflow. This is due to the changing nature of how apps work today: more and more are single-window apps, with integrated tabbing features for working with multiple documents/views/emails/whatevers. I'll admit that this is a bit of an educated guess on my part, but it's based on observations of the functioning of apps used by me and others I know, and I think it's notable that every other platform has switched to a Dock-style paradigm. Clearly they all thought there was some advantage.

I observed quiet the opposite, with large screens and multi monitor setups being the norm in offices, people started to place multiple windows of the same app next to each other for comparison, copy and past, ... And there are very few apps that actually have a split view build in ( e.g. like KDevelop, Kate, Konsole)

FWIW using a dock paradigm isn't bad for multitasking at all in my opinion; you just wind up using Present Windows when you find yourself needing to switch between windows when there are more than like 10 on the screen. I got used to this in my macOS days and it's quite fast. Windows itself seems to have moved to this model as well, as they now ship an IOTM equivalent and have an equivalent of the Present Windows effect.

Have you ever tried Present Window on a bigger screen? The mouse travel distances are ridiculous - and you since you need to hit a window preview, even so its quiet large, in the middle of the screen its a lot harder to aim for then something at a screen edge.

Since Windows itself now defaults to an IOTM equivalent (since Windows 7), and most office workers who have multi-screen setups are using Windows, either an IOTM isn't actually a problem for this use case, or else people with multiple screens are probably the kinds of people who can configure their workspaces for efficiency and aren't impacted as much by the default settings of their OSs.

So I'm not getting a ton of love for the vertical panel idea, which is fine; it's not a critical part of this proposal. Windows uses a horizontal IOTM and the entire world hasn't caught fire yet.

Would folks be happier if we scratch the vertical idea and change the proposal to just use an IOTM and thicken the existing horizontal panel a bit? This would have the benefit of being even more familiar with switching Windows users.

odinu added a subscriber: odinu.EditedJan 9 2020, 10:57 AM

I'd like to argue a bit in favor of the vertical panel. With widescreens being so prevalent and even wider ones on the horizon (ultrawide) it makes little sense to take up the vertical screen space with the taskbar.
On the other hand if you have a browser open, even with 2 windows side by side most pages aren't wide enough to use all the screen space, so a taskbar fits in there as well.
Plus it gives you enough room to make the icons a little bigger and to have 2 smaller icons in the notifications area side-by-side.

Thanks for the support, I quite like it too. :)

So I'm not getting a ton of love for the vertical panel idea, which is fine; it's not a critical part of this proposal. Windows uses a horizontal IOTM and the entire world hasn't caught fire yet.

Would folks be happier if we scratch the vertical idea and change the proposal to just use an IOTM and thicken the existing horizontal panel a bit? This would have the benefit of being even more familiar with switching Windows users.

+1 to IOTM, but I'm not really sold on thickening the panel

While I think the IOTM looks nice, I'm doubting that it will have better usability than the Task Manager.

TL;DR: IOTM better for most users, TTM better when using many windows, IDK which should be default, maybe polling among KDE contributors would give us a clear answer?

AFAICT having a wider IOTM on the left side and having the current TTM on the bottom are both similarly good default choices. Having a higher IOTM at the bottom seems like the worst of both worlds to me.

For me the decision between the two boils down to the usefulness of having the window title next to the application icon. In cases in which there is only one instance of every application open having an IOTM on the left is definitely the better option. I personally use an IOTM most of the time.

But when many instances of the same applications are open I find myself searching for the correct instance too often which considerably disrupts my workflow. At this point I temporarily add the default panel to the bottom. I admit that it might be that I wouldn't need to do that if I had already internalized the "Present Windows" usage instead. This is a valid problem though. What does a user need to learn to be fully effective using an IOTM while having many instances of an application open?

  • Present Windows or clicking the icon and then finding the correct instance
  • Using tabs in applications that aren't a browser (which I can't bring myself to prefer)

Both of these require more clicks than selecting a window by its title in a TTM. When using a TTM there is a seamless transition between using a single instance and using multiple. In a lot of ways the TTM functions as a tabbar like in browsers then.

Despite all of this I think that an IOTM on the left is the best choice for most users. This is mainly because of the saved vertical space and the bigger click targets especially for touch devices like @ngraham already explained.
My concern are those users which really would have a better time using a TTM. Will they be hampered by the IOTM indefinitely, learn to use Present Windows and be happy with it or switch to a TTM? I think it's really hard to tell but we can probably figure out if IOTM is good enough for heavy multitasking by asking KDE contributors what they use. They probably made a concious decision to use one or the other and they probably do heavy multitasking from time to time.

I think that the "many windows" case isn't even all that well-served by the TTM in a lot of circumstances. Consider the following:

Because windows that set custom text put it before the app name rather than after it, you wind up with some Task Manager buttons showing the app name, and others showing a description of the current window content:

So you wind up needing to identify windows by their icons anyway, as with the IOTM.

Also, as you can see in the above screenshot, the button titles start to get elided very aggressively when you actually open many windows. And past a certain point, multiple windows of the same app get grouped, imposing the same slow grouped window selection process as in the IOTM. On my 1920x1080 screen, this happens at 9 open windows with the default panel.

When windows get grouped, it's an abrupt layout change and that breaks the muscle memory you've built up in your session since the other buttons jump around.

I think the TTM works best when it's located on the bottom of a large high resolution screen when you're using a large number of windows from the same app, without too many windows from other apps. The IOTM on the other hand is better for basically every other use case IMO.

After using the TTM for a bit, I think I agree that the IOTM is better, but my main reason for thinking that is mainly because new windows end up all the way at the end in the TTM. Maybe that should be fixed? Possibly off topic.

I think the TTM works best when […] you're using a large number of windows from the same app, without too many windows from other apps. The IOTM on the other hand is better for basically every other use case IMO.

I agree with this part. My TL;DR was a bit poorly worded there: I did mean multiple windows with the same application icon.
I am not sure about IOTMs being better for smaller screens in general. I mean of course on smaller screens one will be more concerned about saving space but if your work demands switching between windows with the same icon the TTM might still be preferable. The bigger argument may be that users on small screens will be less likely to use those for heavy multitasking to begin with. :P Maybe putting the panel on auto-hide is the best option for them.

The Steam hardware survey (Dec 2019) says that about 21 % of Linux steam users have screen sizes of 1440x900 and below. That's a bigger share than I would have expected. I know this isn't really representative of KDE users.

You wind up needing to identify windows by their icons anyway, as with the IOTM.

Yes I think in general when using a TTM the icon is used to identify the application and the title is used to identify the content. That's also why "windows that set custom text put it before the app name rather than after it".

The button titles start to get ellided very aggressively when you actually open many windows.

As long as the ellided title can be used to identify a window I don't see a problem with this. A TM's task is not to show full window titles.

And past a certain point, multiple windows of the same app get grouped, imposing the same slow grouped window selection process as in the IOTM. On my 1920x1080 screen, this happens at 9 open windows with the default panel.

When windows get grouped, it's an abrupt layout change and that breaks the muscle memory you've built up in your session since the other buttons jump around.

I mean I know where you are coming from but this isn't really an argument against TTM imo – It's an argument against grouping in TTM. Maybe window management in that case should work like how Firefox manages having too many tabs. Unfortunately I don't really know the workflow of someone with so many open windows. My most efficient use of TTM in recent times was having 3xLibreOffice, 2xOkular, 1xKate and 1xDolphin open. I was writing some sort of summary for a legal matter (D:) and was able to identify the documents by their title and switch between them with one click. I don't really have a clue how rare such situations are for users.

In any case I still agree that an IOTM on the left is preferable for most users in most situations but I can't tell if switching to it by default is the right choice or not. KDE software is often full of advanced features to make sure users are equipped for difficult tasks. A TTM does seem to better align with that philosophy in my head than an IOTM but I won't complain either way.

In any case I still agree that an IOTM on the left is preferable for most users in most situations but I can't tell if switching to it by default is the right choice or not. KDE software is often full of advanced features to make sure users are equipped for difficult tasks. A TTM does seem to better align with that philosophy in my head than an IOTM but I won't complain either way.

But don't forget the Plasma motto - "Simple by default, powerful when needed." :)

FWIW, I do agree that the workflow of switching between windows in the same app is a weakness of the IOTM compared to the TTM when not grouping. Essentially, the grouping behavior is kind of awkward, but the IOTM exposes you to it sooner by auto-grouping whenever there's more than one window of an app open, while the TTM waits until it gets too crowded using some crowdedness heuristic.

IIRC @hein was working on some backend work that would allow for a mode where clicking on a grouped entry would move the windows of that app to the front one by one without using the Present Windows effect. This is how it's handled by the macOS Dock and the popular Dash To Dock GNOME extension (a fork of which Ubuntu is now shipping by default). I really like that behavior compared to showing the Present Windows effect.

felixernst added a comment.EditedFeb 9 2020, 5:49 PM

That does sound like an improvement! Most of the time users want to switch to the window that they used last anyway so with this change they would only have to click the grouped entry once in this case. It would remain a bit awkward when jumping to the other windows.

FWIW, I do agree that the workflow of switching between windows in the same app is a weakness of the IOTM compared to the TTM when not grouping.

I was trying to find a way to avoid this weakness and came up with this:
The identifying window titles could appear next to identical-looking entries when the IOTM area is hovered.

(Crude mockup of how they could appear while enjoying family friendly music.)

I think the biggest argument against this is that it looks worse the more such window titles appear. But this is also the situation in which they are needed the most. All in all it's quite minimal imo because they only show up when and where needed. They should probably fade in unobtrusively.
Does this sound like a way to overcome IOTM's biggest weakness?

I like that idea, but it would only work in the case where you had turned grouping off in the IOTM. For that use case though, it does seem like a clear win.

For the common case where grouping is on, it doesn't help. I agree that the use case we most want to improve is when you click on a grouped item with the intention of returning to the last-used window in that group, which right now is somewhat awkward. It might make sense to open a new Phab task to discuss this since it's only orthogonally related to this proposal and IMO isn't a blocker (though I would very much like to get it done somehow). Would yo like to open that task?

FWIW my kids (age 4 and 7) love Rammstein. :) It probably helps that they don't know much German yet. :)

It probably helps that they don't know much German yet. :)

I believe it does. :D I once was at one of their concerts.

Would yo like to open that task?

If it wasn't clear yet I really dislike grouping. So much so that I switch to a TTM when a grouped workflow would be necessary. So I am imo the wrong person to open a task for it because I wouldn't even be interested in using the improved version.
Even for the improved version I would still say that it is a similarly good default choice as the TTM.
However I would have some passion for switching to an IOTM if the target was to have an ungrouped IOTM on the left with the idea of my previous comment implemented because at this moment I feel like it might just be the best of both worlds. If that's ever what we are trying to accomplish you can count on my assistance. ^^

FWIW you can in fact turn off grouping on the IOTM now! So if an IOTM was the default, people who hate grouping wouldn't have to stop using it; they could just turn off grouping.

paulm added a subscriber: paulm.Mar 3 2020, 9:13 PM

The position of my panel depends on my display aspect ratio. On a 16:10 or taller screen (which I prefer) I place it on the bottom. In this scenario I think it makes more sense to have the labels as it's more intuitive with more information and allows for a very thin panel, yet still with large clickable areas. It's a waste of space to have a thick panel on the bottom to allow large clickable icons only (like Windows 7 default), as most of it is usually blank; this useless space seems to be why Microsoft added the useless search box in Windows 10.

On a 16:9 (or wider) screen I place the panel on the left very much like the OP's screenshot because there really is no other option to get a decent amount of vertical space. In this case you have to ditch the labels, but have the panel slightly thicker. I think this is still quite space-efficient because the vertical is still smaller than the horizontal. (Also, unlike the OP, I also like to have two columns of system tray icons side-by-side similar to ndavis's screenshot - is there a way to adjust the system tray icon size to adjust to your tastes?)

Perhaps the solution could be to offer an easy one-click customisation screen offering recommended Layout Templates (Perhaps another option at the top of the Customize Layout mode??), with a default recommendation based on your display aspect ratio? I think though that the defaults upon install should be left alone as they are now to avoid confusion; even on 16:9 the Plasma default bottom panel is still thinner than that on Windows.

paulm added a comment.Mar 3 2020, 9:21 PM

IIRC @hein was working on some backend work that would allow for a mode where clicking on a grouped entry would move the windows of that app to the front one by one without using the Present Windows effect. This is how it's handled by the macOS Dock and the popular Dash To Dock GNOME extension (a fork of which Ubuntu is now shipping by default). I really like that behavior compared to showing the Present Windows effect.

Is there anywhere this is being discussed? I actually think the Present Windows effect on Plasma is ingenious and offers better clarity of what you have open than on other DEs. I agree though that on Plasma there is missing a way to get to the last used window of a grouped application. On Windows you can do this by Ctrl-clicking, though double clicking might be more intuitive

spaan added a subscriber: spaan.Mar 4 2020, 12:09 AM

I believe the IOTM should be the default for two reasons.
First and foremost, familiarity. Admittedly, the argument "We should look like Windows" is not very appealing, but I think the value of familiarity for *new users* cannot even be over-estimated (it seems to me that most "How to switch to Linux guides" have agreed that familiar apps and desktop paradigms are helpful). And as IOTM is used by Windows since 2009 (Win 7) this should be our default as well instead of the olden TTM which equals more the old Win XP panel.
Second, usability. One thing TTM cannot do - and probably never will due to the unpredictable position of apps in the panel - is launching and switching apps with Meta+[NUM]. At least to me this feature is huge for when using the keyboard it is the closest I get to the one-click-starting-and-switching-apps for mouse users. Plus, less horizontal/vertical space usage (preventing duplicated icons, wide windows due to text, multiple windows per app).

When it comes to the position I'd be quite hesitant to change the default to left or right because I think this would send us down a huge rabit hole.
Screenshot 1 shows system settings with IOTM left. There are three bars on the left, and IMO three bars is where its starts to look a bit clutter-ish.


Also, I think this would raise some nasty aligning issues combined with visual clutter.
Screenshot 2 shows Firefox with tabs in titlebar having IOTM left.

Icon sizes, positions and backgrounds do not line up very well. And even worse, we cannot know which browser bars the user has enabled to adapt to it.

On a side note, I don't think vertical space can be generally considered more precious than horizontal space. If you are using column-based apps like Thunderbird, Calc, Dolphin with two panes, a tiling terminal etc you might find your horizontal space more precious.

Tldr; My vote is on making IOTM the default, possibly changing the size after testing all relevant display resolutions, and placing it on the bottom by default.

I personally always use the IOTM, on a panel on the left. The panel is always scaled exactly so the system tray icons are in two columns. I'm also very fond of the present windows effect when you click on a grouped application icon - recognizing the window I need and switching to it is 10x faster and easier simply due to size than on Windows, where one only gets the small window previews.
The IOTM in total is a lot faster than a TTM because with a TTM one has to read the labels - with the IOTM you get visual indicators all the way, big icons for the app and then the window content itself for the actual window switching. The consistency of the position of apps on the TM is also a bonus on usability and speed.

I would say we should make the panel on the left the default but set it to "windows can cover". My reasoning is that we don't waste any screen space at all and at the same time don't have the problem of pure auto hide, where the user first has to discover the panel at all. It also solves the problem of the side bar clutter.
The problem that remains is of course the hot corner for present window if we keep the titlebar buttons on the right.

Overall I still think that T11743 would be the best option but we should IMO definitely not just ship these other configurations but also provide a "Plasma default", everything else will just come across as if we were only doing cheap copies of other OSs setups. This discussion is still valid whether or not we're going through with T11743.

(Also, unlike the OP, I also like to have two columns of system tray icons side-by-side similar to ndavis's screenshot - is there a way to adjust the system tray icon size to adjust to your tastes?)

Yes, two columns is the default. I just change it for mine. There's a hidden setting with no UI; you add iconSize=2 (or a larger number) to ~/.config/plasma-org.kde.plasma.desktop-appletsrc in the section that has extraItems= in it. This is my workaround for the fact that the icon sizing/number of columns isn't configurable in the UI and can't auto-adept to the thickness of your panel (one of which I think should be implemented), but that's another matter. :)

When it comes to the position I'd be quite hesitant to change the default to left or right because I think this would send us down a huge rabit hole. Screenshot 1 shows system settings with IOTM left. There are three bars on the left, and IMO three bars is where its starts to look a bit clutter-ish.

Nobody's making you maximize the window. :) As your screenshot shows, there's a huge amount of wasted space on the right and clutter on the left when you do. So just don't maximize the window. :)


So far I haven't heard any significant objections to the idea of using an IOTM instead of a TTM, and a lot of support. The biggest complaint seems to be that the current workflow for switching between windows that have been grouped is slow and cumbersome--primarily driven by unhappiness with the use of the Present Windows effect (though this is not universal; some people seem to like it just fine). However the IOTM can now be configured to stop grouping entirely, which seems like it could be an acceptable workaround for people seriously impacted by it. And of course the TTM will still be available for people who just don't like the IOTM. So I would propose that we move forward with that.

With regards to putting it on a left panel by default, this seems more controversial. Do we think we need more discussion on the matter? Personally I'd really like to move in that direction. as I think it dovetails very well with the use of an IOTM and substantially improves the out-of-the-box touch-friendliness of the shell.

Strong +1 to IOTM. Let's move forward with it.

merritt added a subscriber: merritt.Mar 4 2020, 6:31 PM

+1 for IOTM as default (but not a fan of left-side panel)

It is my preferred way to work, and I think more familiar for most computer users. It also looks nice.

+1 for thickening panel by default

I have my panel at 44 px, just big enough so the icons are clear and good-looking without taking up too much screen real estate.
(As a tangent, the fact the px # disappears while I am configuring the panel is frustrating.)

All right, I'll put together a patch for a thickened bottom panel with an IOTM on it and some pre-pinned apps. We can discuss moving it the left (or not) later, if it lands. :)

Some more things that may or may not have already been mentioned, given that some of us are considering the idea of moving the hotcorner to the bottom since it'd get in the way of the panel up top:

  • Bottom-right hotcorner: Gets in the way of scrollbars...? (also mouse resting area)
  • Bottom-left hotcorner: Gets in the way of Show Desktop (and the Panel Toolbox in Global Edit Mode)
  • Bottom-center hotcorner: You'd, er, have to implement that first.
paulm added a comment.EditedMar 5 2020, 5:54 PM

Some more things that may or may not have already been mentioned, given that some of us are considering the idea of moving the hotcorner to the bottom since it'd get in the way of the panel up top:

  • Bottom-right hotcorner: Gets in the way of scrollbars...? (also mouse resting area)
  • Bottom-left hotcorner: Gets in the way of Show Desktop (and the Panel Toolbox in Global Edit Mode)
  • Bottom-center hotcorner: You'd, er, have to implement that first.

I use a panel docked to the left and have the show desktop in the bottom-left. I placed the Present Windows to the bottom-left hot-corner as well and find it works rather well. The two functions of show desktop and present all windows logically work well together. They don't really interfere with each other as if you want to show the desktop you just don't move the mouse all the way to the bottom left.

This gives you in a typical browsing window: Top-left: start, top right: close, bottom right: scroll (I hate that the default is now to disable the scroll arrows by the way - this is useful for precise scrolling, and you can't change through the UI the Breeze GTK setting to turn it back on), bottom-left Show Desktop/Present Windows.

Perhaps these bottom-left functions could be combined together at some stage - for example clicking the Show Desktop widget once could present windows and double-clicking shows the desktop? I think you could also combine the multiple desktop feature in here like Microsoft has done in Task View for Windows 10.

Another inconsistency is that the recently new show desktop icon now will need changed for a panel on the left.

paulm added a comment.Mar 5 2020, 5:57 PM

All right, I'll put together a patch for a thickened bottom panel with an IOTM on it and some pre-pinned apps. We can discuss moving it the left (or not) later, if it lands. :)

If you're going to go ahead and thicken the panel you might as well also move it to the left as that is more space-efficient for a thicker panel on a typical 16:9 display.

ngraham added a comment.EditedMar 5 2020, 9:36 PM

The discussion in D27845 has gotten slightly derailed because we can't seem to agree on a new panel thickness. Some think that a thickness in the high 40s would be best, while a vocal cohort would prefer 38, or 40 at the most. Their argument is that a thicker panel accumulates more visual weight, which becomes excessive at some point when the panel is on the bottom of the screen on a very long edge. I can see that point of view, and to me this just points back to using a thick left edge vertical panel again. Being on a shorter edge, we'd have more visual latitude to thicken the panel as originally proposed, yielding the originally-mentioned goal of better touch friendlines too.

gvgeo added a subscriber: gvgeo.Mar 6 2020, 9:13 AM

Vertical panel has limited space for time and date. If time could get bigger numbers, would be +1 from me.

Example of "am" getting smaller in favor of bigger numbers, still small but better. At the right, normal font size for time I use in a 32 pixel panel.

If we go with a vertical panel, it will be thicker than 32px for sure :) Here's how it all looks with a 60px vertical panel for example:

60px may seem high, but when the panel is vertical, the visual weight of such a thick panel really isn't a problem IMO.

gvgeo added a comment.Mar 6 2020, 3:10 PM

Currently the default font size for time is 17. In picture above is 10 or 9 with the extra "1" (at 10 o'clock). I feel that needs to be bigger, otherwise better stay as is.
That's why I made "am" smaller, to make the time in description's example size 12.

(About width, I would prefer around 45. But again, the time would be tiny. Unless you 'd like a nice vertical clock, ha ha ha.)

eszlari added a subscriber: eszlari.EditedMay 15 2020, 7:57 AM

I think for the default(!) settings, familiarity trumps everything else. That's why I think, a vertical panel is a bad idea. There is a reason why Mate, Cinnamon, Xfce, LXDE etc exist, why Mint is such a popular distribution and why I even see a lot of screenshots of people moving the panel to the bottom on GNOME. People coming from Windows want a familiar environment and they make up still the vast majority of potential future users. KDE should not make the same mistake as GNOME by ignoring this simple fact, and corner itself in some "obsessed with design details" bubble.

I think it would make more sense, to have analog to the globel theme kcm, a global layout kcm. This would match KDE's motto: Simple (=familiar) by Default Powerful When Needed.

The vertical panel is a recognizable feature of Ubuntu, more precisely Ubuntu have horizontal panel on top (there is a time/date and system tray) and vertical dock/dash on the left (there is only a apps).


In this task offers to fit everything in vertical panel, that looks ugly if compared it with Ubuntu, especially system tray and time/date.

ngraham updated the task description. (Show Details)May 26 2020, 1:58 PM

In this task offers to fit everything in vertical panel, that looks ugly if compared it with Ubuntu, especially system tray and time/date.

I think this is the key point here. With the vertical panel, you end up with huge icons and a relatively tiny clock. That's the opposite of the horizontal panel, with normal-sized icons and humongous widget text. Both look inconsistent and messy.

a relatively tiny clock

The clock will be a lot bigger in most non-english speaking countries:
https://en.wikipedia.org/wiki/Date_and_time_representation_by_country#Time

<- Looks good imo. I think it looks okay even with AM/PM. The only thing I would say is ugly is the "Show Desktop" icon but that is mostly unrelated to this task.

ngraham closed this task as Resolved.Jun 12 2020, 5:42 PM

After discussion at the Plasma sprint, we went with D27845: Replace Task Manager with Icons-Only-Task Manager in the default panel, and thicken it. Aaaand it's now in for Plasma 5.20!